PImage[] images = new PImage[10000];
PGraphics topLayer; 

int imageCounter;
 
boolean saveSequence = false;
boolean playSequence = false;
boolean redrawSequence = false;

void setup(){
  size(720, 480);
  background(0); 
  noStroke();
  imageCounter=0;  
  topLayer = createGraphics(width, height, g.getClass().getName());
}
 
void draw() {
  frameRate(60);

  if(playSequence == true && images[imageCounter] != null){
    set(0, 0, images[imageCounter]);
    saveFrame("heHatesMe001-######.tif");
    imageCounter++;
  } 
  
  fill(0, 30);
  noStroke();
  rect(0, 0, 720, 480);
  stroke(255);
  strokeWeight(4);
  smooth();
  // Draw if mouse is pressed
  if (mousePressed) {
    line(pmouseX, pmouseY, mouseX, mouseY);
    strokeWeight(5);
    point(mouseX, mouseY);    
  }
  if(keyPressed){
    if(key == 's' || key == 'S'){
      imageCounter = 0;
      playSequence = false;
      saveSequence = true;
    }
    if(key == 'x' || key == 'X'){
       saveSequence = false;
    }    
    if(key == 'p' || key == 'P'){
      imageCounter = 0;
      redrawSequence = false;
      playSequence = true;
//      image(images[3], 0, 0);
    }
    if(key == 'r' || key == 'R'){
      imageCounter = 0;
      playSequence = false;
      redrawSequence = true;
    }
  }
  
  if(saveSequence == true){
    images[imageCounter] = get();
    imageCounter++;
  } 

  if(redrawSequence && images[imageCounter] != null){
      topLayer.beginDraw();
      topLayer.set(0, 0, images[imageCounter]);
      topLayer.tint(255, 255);
      topLayer.endDraw();
      tint(255, 126); 
      image(topLayer, 0, 0);
      imageCounter++;
  }
}
